%%
% planteamiento ecuaciones diferenciales convertidor
%clear all
clc
vinp=189.5;

cp=1500e-6;
c=6000e-6;
rp=4.065;

rbat=0.120;
%0.17706*20;
l=5e-3;
vbat=11.5*20; 




syms il vp vc d vprom
%vpp= vinp/(rp*cp)-il/cp-vp/(rp*cp)
%ilp= vp/l-(vc*(1-d))/l
%vcp= (il*(1-d))/c-vc/(c*rbat)+vbat/(c*rbat)
%punto de equilibrio



[il,vc,vp]=solve(vinp/(rp*cp)-il/cp-vp/(rp*cp)==0, vp/l-(vc*(1-d))/l==0, (il*(1-d))/c-vc/(c*rbat)+vbat/(c*rbat)==0);
vpn=154.5;

Q=solve(vpn==vp);
d=Q(1);
ilprom=(d*vbat-vbat+vinp)/(d^2*rbat-2*d*rbat+rbat+rp);
vcprom=-(d*rbat*vinp-rbat*vinp-rp*vbat)/(d^2*rbat-2*d*rbat+rbat+rp);
vpprom=((d-1)*((d*rbat*vinp-rbat*vinp-rp*vbat)))/(d^2*rbat-2*d*rbat+rbat+rp);
dprom=Q(1);
A=double([-1/(rp*cp),-1/cp,0;1/l,0,(dprom-1)/l;0,(1-dprom)/c,-1/(c*rbat)]);
B=double([1/(rp*cp),0,0;0,0,-vcprom/l;0,1/(c*rbat),-ilprom/c]);
C=double([1,0,0]);
D=double([0,0,0]);

% C=double([1,0,0;0,1,0;0,0,1]);
% D=double([0,0,0;0,0,0;0,0,0]);
[num,den]=ss2tf(A,B,C,D,3);
[numB,denB]=ss2tf(A,B,C,D,2);
[numV,denV]=ss2tf(A,B,C,D,1);
X=tf(num,den); 

Cc=double([0,0,1]);
[Vcnum,Vcden]=ss2tf(A,B,Cc,D,3);
XVc=tf(Vcnum,Vcden)

r1=390000;
r2=5241.94;
Vth1= r2/(r2+r1);%panel
Vth2= r1/(r1+r2);%temperatura 



%%
%calculo PI VPanel
X=tf(num,den); 
X=X*Vth1;
Planta=c2d(X,20e-6,'zoh');
Ccontrol=tf([57.378e-3 -56.379e-3],[1 -1],20e-6,'variable','z^-1')%sisotool tiempo establecimiento 0.009 robustes de 0.8
%%
%calculo PI Vc

Planta=c2d(X,20e-6,'zoh');
Ccontrol=tf([53.321e-3 -52.3985e-3],[1 -1],20e-6,'variable','z^-1')%sisotool tiempo establecimiento 0.009 robustes de 0.8

%%
%calculo PI
%funcion profesor
r1=390000;
r2=5241.94;
r3=330000;
r4=220000;
c1=0.1e-9;
c2=0.47e-6;
Rth=((r1*r2)/(r1+r2))+r3;
Vth1= r2/(r2+r1);
Vth2= r1/(r1+r2);
numc=[c2*r4 1];
denc=[c2*c1*r4 (c1+c2) 0]*Rth;
F=tf(numc,denc);
%%
% planteamiento ecuaciones diferenciales convertidor
vinp=189.5;

cp=1500e-6;
c=6000e-6;
rp=4.065;
Vini=209;
rbat=0.150;
%0.17706*20;
l=5e-3;
for i=1:70
    Vbattery(i)= Vini+i;
end
for j=1:70




syms il vp vc d vprom
%vpp= vinp/(rp*cp)-il/cp-vp/(rp*cp)
%ilp= vp/l-(vc*(1-d))/l
%vcp= (il*(1-d))/c-vc/(c*rbat)+vbat/(c*rbat)
%punto de equilibrio


vbat=Vbattery(j);
[il,vc,vp]=solve(vinp/(rp*cp)-il/cp-vp/(rp*cp)==0, vp/l-(vc*(1-d))/l==0, (il*(1-d))/c-vc/(c*rbat)+vbat/(c*rbat)==0);
vpn=154.5;

Q=solve(vpn==vp);
d=Q(1);
ilprom=(d*vbat-vbat+vinp)/(d^2*rbat-2*d*rbat+rbat+rp);
vcprom=-(d*rbat*vinp-rbat*vinp-rp*vbat)/(d^2*rbat-2*d*rbat+rbat+rp);
vpprom=((d-1)*((d*rbat*vinp-rbat*vinp-rp*vbat)))/(d^2*rbat-2*d*rbat+rbat+rp);
dprom=Q(1);
A=double([-1/(rp*cp),-1/cp,0;1/l,0,(dprom-1)/l;0,(1-dprom)/c,-1/(c*rbat)]);
B=double([1/(rp*cp),0,0;0,0,-vcprom/l;0,1/(c*rbat),-ilprom/c]);
C=double([1,0,0]);
D=double([0,0,0]);

%C=double([1,0,0;0,1,0;0,0,1]);
%D=double([0,0,0;0,0,0;0,0,0]);
[num,den]=ss2tf(A,B,C,D,3);
[numB,denB]=ss2tf(A,B,C,D,2);
[numV,denV]=ss2tf(A,B,C,D,1);
X(j)=tf(num,den); 

end
for i=1:70
    bode(X(i));
    hold on
end    
r1=390000;
r2=5241.94;
Vth1= r2/(r2+r1);%panel
Vth2= r1/(r1+r2);%temperatura 




%%
%Graficas comparacion modelo

plot(Vpanel_FT.Time,Vpanel_FT.Data,'r')
hold on
plot(Vpanel_Real.Time,Vpanel_Real.Data,'b')
title('Voltaje panel FT vs Real ','FontSize',24)
xlabel('Tiempo (s)','FontSize',14)
legend('Vpanel_FT','Vpanel_Real')
%%
%Graficas Control Analogico
plot(Potencia_MPPTReal_FT.Time,Potencia_MPPTReal_FT.Data,'g')
hold on
plot(Potencia_MPPT_ideal.Time,Potencia_MPPT_ideal.Data,'b')
hold on
plot(Potencia_MPPTReal.Time,Potencia_MPPTReal.Data,'r')
hold on
plot(MPPT_plantapa.Time,MPPT_plantapa.Data,'g')
title('Potencia real vs Potencia ideal (Control analogico) ','FontSize',20)
xlabel('Tiempo (s)','FontSize',14)
legend('Potencia Real','Potencia Ideal','Potencia ft')
%%
%Graficas P&O
plot(MPPT_ideal.Time,MPPT_ideal.Data,'g')
hold on
plot(MPPT_PO.Time,MPPT_PO.Data,'b')
%plot(MPPT_Real.Time,MPPT_Real.Data,'r')
title('Potencia Convertidor','FontSize',20)
xlabel('Tiempo (s)','FontSize',14)
%legend('Potencia Ideal','Potencia Calculada A-C')
%,'Potencia Calculada D-C'

%%
%GRAFICAS CONTROL PI calculado
figure
plot(MPPT_ideal.Time,MPPT_ideal.Data,'g')
hold on
%MPPT_PO=V*Iac;
%plot(MPPT_PO.Time,MPPT_PO.Data,'b')
MPPT_Real=V*Ibc;
plot(MPPT_Real.Time,MPPT_Real.Data,'r')
title('Potencia Convertidor','FontSize',20)
xlabel('Tiempo (s)','FontSize',14)
legend('Potencia Ideal','Potencia Calculada A-C')
%%
%GRAFICAS CONTROL ANALGICO
figure
plot(P_ideal.Time,P_ideal.Data,'g')
hold on
%plot(MPPT_PO.Time,MPPT_PO.Data,'b')
plot(MPPT_Real.Time,MPPT_Real.Data,'r')
title('Potencia Convertidor','FontSize',20)
xlabel('Tiempo (s)','FontSize',14)
legend('Potencia Ideal','Potencia Calculada A-C')
%%
Erms=mean(sqrt((MPPT_ideal.Data-MPPT_Real.Data).^2));
Porc=((MPPT_ideal.Data-MPPT_Real.Data).*100)./MPPT_Real.Data;

plot(MPPT_ideal.Time(100000:end),Porc(100000:end))
%%
plot(Vref.Time,Vref.Data,'g')

%%
plot(PWM.Time,PWM.Data,'g')
%%
plot(V.Time,V.Data,'g')

%%
hold on
plot(Iac.Time,Iac.Data,'b')

%%
Pot=V*Ibc;
plot(Pot.Time,Pot.Data,'R')
hold on
plot(MPPT_ideal.Time,MPPT_ideal.Data,'g')

%%
plot(Ibc.Time,Ibc.Data,'g')
%%
plot(D.Time,D.Data,'g')
%%
plot(triangulo.Time,triangulo.Data,'g')
%%
plot(dP.Time,dP.Data,'r')
%%
figure
plot(dV.Time,dV.Data,'g')
%%
plot(Vbat.Time,Vbat.Data,'r')
%%
plot(VTemp.Time,VTemp.Data,'r')
%%
plot(Vref.Time,Vref.Data,'r')

%%
%pi siso
% 0.031421 (s+122.5)
% ------------------
%         s


%%
%perfil cambios 

t= linspace(0,2,20000001);
sen=1000*sin(pi/2*t);
plot(t,sen,'b')
% tn=[t,linspace(2+0.1e-6,3,10000000)];
% ln = length(tn)-length(sen);
% Data_n = [zeros(1,ln),sen];
perfilIrra=timeseries(sen.',t.');
%plot(perfilIrra.Time,perfilIrra.Data,'b');
for i=1:20000001

    if(i<7000000)
    cua(1,i)=25;
    end
    if(i>=7000000 && i<14000000)
    cua(1,i)=60;
    end
    if(i>=14000000)
    cua(1,i)=35;
    end
end
PerfilTemp=timeseries(cua.',t.');
figure
plot(PerfilTemp.Time,PerfilTemp.Data,'b');

%%
%perfil constante 
T=7e6+1;
t= linspace(0,7,T);
for i=1:T
    sen(1,i)=1000;
end
perfilIrra=timeseries(sen.',t.');
plot(perfilIrra.Time,perfilIrra.Data,'b');
hold on
for i=1:T

    cua(1,i)=25;

end
PerfilTemp=timeseries(cua.',t.');
plot(PerfilTemp.Time,PerfilTemp.Data,'b');
 %%
T=7e6+1;
t= linspace(0,7,T);
for i=1:T
if(i<1e6)
    sen(1,i)=200;
end

if(i>=1e6 && i<2e6)
    sen(1,i)=400;
end

if(i>=2e6 && i<3e6)
    sen(1,i)=800;
end

if(i>=3e6 && i<4e6)
    sen(1,i)=1000;
end

if(i>=4e6 && i<5e6)
    sen(1,i)=800;
end

if(i>=5e6 && i<6e6)
    sen(1,i)=400;
end

if(i>=7e6)
    sen(1,i)=200;
end


end
 

perfilIrra=timeseries(sen.',t.');

for i=1:T

    if(i<2.4e6)
    cua(1,i)=25;
    end
    if(i>=2.4e6 && i<4.8e6)
    cua(1,i)=60;
    end
    if(i>=4.8e6)
    cua(1,i)=35;
    end
end
PerfilTemp=timeseries(cua.',t.');


  