%clear all
clc
Rds=88e-3;
Rlo=6.9;

Lo=1e-3;
Co=50e-6;
Vin=240;
Vo=170;
io=0.00141;
% d=linspace(0,1,100);
% io=linspace(6,-6, 100);
% for(i=1:100)
% Ilprom(i)=io(i)/(2*d(i)-1);
% Voprom(i)=(Vin*(4*d(i)^2-4*d(i)+1)-io(i)*(Rds+Rlo))/(2*d(i)-1);
% end
syms Ilprom d 
[ilo,d]=solve(Ilprom==io/(2*d-1),Vo==(Vin*(4*d^2-4*d+1)-io*(Rds+Rlo))/(2*d-1));

double(ilo)
double(d)

D=double(d(2));
Ilo=double(ilo(2));

A=double([-(Rds+Rlo)/Lo,-1/Lo;(2*D-1)/Co,0;]);
B=double([(2*D-1)/Lo,0,2*Vin/Lo;0,-1/Co,2*Ilo/Co]);
C=double([0,1]);
D=double([0,0,0]);

[num,den]=ss2tf(A,B,C,D,3);
Vod=tf(num,den);


C=double([1,0]);
D=double([0,0,0]);
[numB,denB]=ss2tf(A,B,C,D,3);
Ilod=tf(numB,denB);


%%
%PI Voltaje
%%
%calculo PI 
X=tf(num,den); 
Planta=c2d(X,20e-6,'zoh');
sisotool(Planta);%sisotool tiempo establecimiento 0.0017 robustes de 0.6
Ccontrol=tf([0.00071868 -0.00063567],[1 -1],20e-6,'variable','z^-1')%fredy
Ccontrol=tf([7.6797e-05 -2.7370e-05],[1 -1],20e-6,'variable','z^-1')
step(feedback(Planta*Ccontrol,1))
title('Entrada paso V_{out} + PI')

%%

%%funciones de tranferencia
clear all
clc
Rds=88e-3;
Rlo=2;
Rlm=9e-3;
Lo=1e-3;
Co=50e-6;
Vo=170;

%para Vo positivo

Vinn=linspace(210,280,8);

ioo=linspace(0,6,6);
d=linspace(0,1,100);
io=linspace(6,-6, 100);
for(i=1:100)
Ilprom(i)=io(i)/(2*d(i)-1);
Voprom(i)=(Vin*(4*d(i)^2-4*d(i)+1)-io(i)*(Rds+Rlo))/(2*d(i)-1);
end

for i=1:8
    Vin=Vinn(i);
    for j=1:6
        io=ioo(j);
syms Ilprom d 
[ilo,d]=solve(Ilprom==io/(2*d-1),Vo==(Vin*(4*d^2-4*d+1)-io*(Rds+Rlo))/(2*d-1));



D=double(d(2));
Ilo=double(ilo(2));

A=double([-(Rds+Rlo)/Lo,-1/Lo;(2*D-1)/Co,0;]);
B=double([(2*D-1)/Lo,0,2*Vin/Lo;0,-1/Co,2*Ilo/Co]);
C=double([0,1]);
D=double([0,0,0]);

[num,den]=ss2tf(A,B,C,D,3);
Vod=tf(num,den);
bode(Vod);
hold oncuc
    end
end
% 
% C=double([1,0]);
% D=double([0,0,0]);
% [numB,denB]=ss2tf(A,B,C,D,3);
% Ilod=tf(numB,denB);
%%
input=0
for i=1:5000
  
    a(i)=(sin(120*pi*input)*170);
    input=input+0.0006;
end
plot(a);

%%
%bode mas inestable
%potencia maxima es de 300W
clc
Rds=88e-3;
Rlo=6.9;

Lo=1e-3;
Co=50e-6;
Vo=170;
io=linspace(1.41e-3,1.75,10);
Vin=linspace(210,270,14);
 
% for(i=1:100)
% Ilprom(i)=io(i)/(2*d(i)-1);
% Voprom(i)=(Vin*(4*d(i)^2-4*d(i)+1)-io(i)*(Rds+Rlo))/(2*d(i)-1);
% end
 
for (i=1:10)    
    for (j=1:14)
        syms Ilprom d
        [ilo,d]=solve(Ilprom==io(i)/(2*d-1),Vo==(Vin(j)*(4*d^2-4*d+1)-io(i)*(Rds+Rlo))/(2*d-1));
        D=double(d(2));
        Ilo=double(ilo(2));
        A=double([-(Rds+Rlo)/Lo,-1/Lo;(2*D-1)/Co,0;]);
        B=double([(2*D-1)/Lo,0,2*Vin(j)/Lo;0,-1/Co,2*Ilo/Co]);
        C=double([0,1]);
        D=double([0,0,0]);

        [num,den]=ss2tf(A,B,C,D,3);
        Vod=tf(num,den);
        bode(Vod)
        hold on
        clear A B C D Vod num den Ilo D ilo d Ilprom d
    end
    
end
