%%
% planteamiento ecuaciones diferenciales convertidor
%clear all
clc
vinp=189.5;

cp=1500e-6;
c=6000e-6;
rp=32.71;

rbat=0.120;
%0.17706*20;
l=5e-3;
vbat=11.5*20; 




syms il vp vc d vprom
%vpp= vinp/(rp*cp)-il/cp-vp/(rp*cp)
%ilp= vp/l-(vc*(1-d))/l
%vcp= (il*(1-d))/c-vc/(c*rbat)+vbat/(c*rbat)
%punto de equilibrio



[il,vc,vp]=solve(vinp/(rp*cp)-il/cp-vp/(rp*cp)==0, vp/l-(vc*(1-d))/l==0, (il*(1-d))/c-vc/(c*rbat)+vbat/(c*rbat)==0);
vpn=155.7;

Q=solve(vpn==vp);
d=Q(1);
ilprom=(d*vbat-vbat+vinp)/(d^2*rbat-2*d*rbat+rbat+rp);
vcprom=(-(d*rbat*vinp-rbat*vinp-rp*vbat)/(d^2*rbat-2*d*rbat+rbat+rp));
vpprom=((d-1)*((d*rbat*vinp-rbat*vinp-rp*vbat)))/(d^2*rbat-2*d*rbat+rbat+rp);
dprom=Q(1);
A=double([-1/(rp*cp),-1/cp,0;1/l,0,-(1-dprom)/l;0,(1-dprom)/c,-1/(c*rbat)]);
B=double([1/(rp*cp),0,0;0,0,vcprom/l;0,1/(c*rbat),-ilprom/c]);
C=double([1,0,0]);
D=double([0,0,0]);

% C=double([1,0,0;0,1,0;0,0,1]);
% D=double([0,0,0;0,0,0;0,0,0]);
[num,den]=ss2tf(A,B,C,D,3);
[numB,denB]=ss2tf(A,B,C,D,2);
[numV,denV]=ss2tf(A,B,C,D,1);
X=tf(num,den); 

Cc=double([0,0,1]);
[Vcnum,Vcden]=ss2tf(A,B,Cc,D,3);
XVc=tf(Vcnum,Vcden)

r1=390000;
r2=5241.94;
Vth1= r2/(r2+r1);%panel
Vth2= r1/(r1+r2);%temperatura 


inicondi=[double(vpprom) double(ilprom) double(vcprom)]
%%
%calculo PI VPanel
X=tf(num,den); 
X=X*Vth1;
Planta=c2d(X,20e-6,'zoh');
sisotool(Planta);%sisotool tiempo establecimiento 0.009 robustes de 0.8
Ccontrol=tf([-57.253e-3 56.263e-3],[1 -1],20e-6,'variable','z^-1')
step(feedback(Planta*Ccontrol,1))
%%
%calculo PI Vc
XVc=tf(Vcnum,Vcden);
Bat=c2d(XVc,20e-6,'zoh');
%sisotool(Bat);%sisotool tiempo establecimiento 0.004 robustes de 0.2
Cctrl=tf([0.034076 -0.03336],[1 -1],20e-6,'variable','z^-1')%sisotool tiempo establecimiento 0.009 robustes de 0.8
step(feedback(Bat*Cctrl,1))